<?php

namespace Modules\Slider\Controllers\Admin;

/** Ajax Request */

use App\Services\Response\ResponseService;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use App\Http\Controllers\Controller;
use Modules\Product\Services\ProductService;
use Modules\Slider\Requests\Admin\SliderRequest;
use Modules\Slider\Services\SliderService;

class SliderController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/sliders';
    /** View folder */
    private $viewDirectory= 'admin.sliders.';
    //

    public function __construct(
        private SliderService $sliderService,
        private ProductService $productService,
    )
    {}

    /**
     * Display a listing of the sliders.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('sliders.head');
        $products = $this->productService->get([]);
        return view($this->viewDirectory.'index', get_defined_vars());
    }

    /**
     * return data of the sliders.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $request->merge(['paginate'=>true]);
        $sliders= $this->sliderService->get($request->all());

        return view($this->viewDirectory.'grid',get_defined_vars());
    }

    /**
     * Show the form for creating a new Slider.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('sliders.store');
        $head= __('sliders.new');
        $products = $this->productService->get([]);
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Store a newly created Slider in storage.
     * @param SliderRequest $request
     * @return JsonResponse
     */
    public function store(SliderRequest $request) :JsonResponse
    {
        $this->sliderService->create($request->validated());

        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('sliders.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Show the form for editing the specified Slider.
     *
     * @param  int $id
     * @return View
     */
    public function edit(int $id) :View
    {
        $slider = $this->sliderService->getItem($id);
        if (!$slider)
        {
            abort(404);
        }
        $action= route('sliders.update', $slider->id);
        $head= __('sliders.edit');
        $products = $this->productService->get([]);
        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Update the specified Slider in storage.
     * @param SliderRequest $request
     * @param int $id
     * @return JsonResponse
     */
    public function update(SliderRequest $request, int $id) :JsonResponse
    {
        $slider = $this->sliderService->checkItem($id);
        if (!$slider)
        {
            abort(404);
        }
        $this->sliderService->update($request->validated(), $id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('sliders.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove the specified Slider from storage.
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(int $id) :JsonResponse
    {
        $this->sliderService->destroy($id);
        session()->flash('message', __('dashboard.saveDone'));
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('sliders.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Remove several sliders by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $this->sliderService->destroyAll([
            'ids' => $request->ids,
            'status' => 1
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('sliders.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore the specified Slider from storage.
     *
     * @param int $id
     * @return JsonResponse
     */
    public function restore(int $id) :JsonResponse
    {
        $this->sliderService->destroy($id);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('sliders.index'),
        ];
        return ResponseService::response($response);
    }

    /**
     * Restore several sliders by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $this->sliderService->destroyAll([
            'ids' => $request->ids,
            'status' => 0
        ]);
        $response = [
            'status'=>200,
            'message'=>__('web.success'),
            'data'=> route('sliders.index'),
        ];
        return ResponseService::response($response);
    }
}
